/*
    Copyright 2007, 2008, 2009, 2010 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef COMMANDPARSER_H_
#define COMMANDPARSER_H_


#define KNOWNPREDEFINES {   "ThisDirectory","TDIR",\
                            "OtherDirectory","ODIR",\
                            "LeftSideDirectory", "LDIR",\
                            "RightSideDirectory", "RDIR",\
                            "Home", "HOME",\
                            "AllItemsWithoutPathUnQuoted", "MIS_NP_UQ", \
                            "AllItemsWithoutPathQuoted", "MIS_NP_Q", \
                            "AllItemsWithPathUnQuoted", "MIS_WP_UQ", \
                            "AllItemsWithPathQuoted", "MIS_WP_Q", \
                            "ItemWithoutPathUnQuoted", "MI_NP_UQ", \
                            "ItemWithoutPathQuoted", "MI_NP_Q", \
                            "ItemWithPathUnQuoted", "MI_WP_UQ", \
                            "ItemWithPathQuoted", "MI_WP_Q", \
                            "home" \
                        }
#define NUMBEROFPREDEFINES 27	//Change this if you add or remove a String to/from KownPredefines
								//Do not forget to change function decryptPredefine <- its the onl



struct _predefineStruct{
    GString *gstrThisSidePath;  //do not free, comes from _CallUserCommand_StartThreadStructure
    GString *gstrOtherSidePath; //do not free, comes from _CallUserCommand_StartThreadStructure
    GString *gstrLeftSidePath;  //do not free, comes from _CallUserCommand_StartThreadStructure
    GString *gstrRightSidePath; //do not free, comes from _CallUserCommand_StartThreadStructure
    GString *gstrHomeDir;       //do not free, comes from _CallUserCommand_StartThreadStructure
    //GString *gstrWorkingPath;   //do not free, freed in CallUserCommand_CallToSystem

    GString *gstrAllMarkedItems_WithoutPath_Unquoted;
    GString *gstrAllMarkedItems_WithoutPath_Quoted;
    GString *gstrAllMarkedItems_WithPath_Unquoted;
    GString *gstrAllMarkedItems_WithPath_Quoted;

    GString *gstrOneMarkedItem_WithoutPath_Unquoted;    //OneMarkedItem strings are only valid in each and list mode
    GString *gstrOneMarkedItem_WithoutPath_Quoted;      //in all mode they are the same as the AllMarkedItems strings
    GString *gstrOneMarkedItem_WithPath_Unquoted;
    GString *gstrOneMarkedItem_WithPath_Quoted;
};


int ParseXMLUserCommand (struct _CallUserCommand_StartThreadStructure *ThreadStartStruct, GString **gstrpParsedCommand, GString **gstrpQuitReplyText, GString **gstrpActionNoteText, GString *gstrWorkingPath);

int ParseUserCommand(GString *Command, GString *FileList, GString *FileListWithPath, GString *WorkPath, GString *OtherSidePath, GString **ActionNoteText, GString **QuitReplyText, struct updateList **UpdateFolderWhenFinished_List);
int UserCommandCallType(GString *Command, int *ip_CallType, GString **gstrCaption, GString **gstrLabel, GString **gstrCall);
int newUsercommandReadOverSeveralLines(FILE *thefile,char *commandPart);


#endif /*COMMANDPARSER_H_*/


