/*
    Copyright 2007, 2008, 2009, 2010 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdkkeysyms.h>

#include "mytrace.h"
#include "globalDefinitions.h"
#include "helpers.h"
#include "Lists.h"
#include "userdata.h"
#include "myfm.h"
#include "confighandlingDefinitions.h"
#include "confighandling.h"
#include "propertyPage.h"
#include "CreateUsercommandDialog.h"

#include "allInclude.h"

#define DIALOGCAPTION "Cat'sEyE Create User Command"


extern GtkWindow 	*win;
extern struct _UserCommandList *g_UserCommandList;


struct _CreateUsercommandDialogElements{
    GtkWidget *mainWidget;

    GtkWidget *btnChange;
    GtkWidget *btnAdd;
    GtkWidget *btnCreate;
    GtkWidget *btnClose;
    GtkWidget *hboxBtnBox;

    GtkWidget *lblName;
    GtkWidget *ntryName;
    GtkWidget *vboxName;

    GtkWidget *lblCommand;
    GtkWidget *ntryCommand;
    GtkWidget *vboxCmndBox;

    GtkWidget *chkIsDefaultCommand;
    GtkWidget *lblCalltype;
    GtkWidget *cmbCalltype;
    GtkWidget *hboxCalltype;

    GtkWidget *lblTargets;
    GtkWidget *ntryTargets;
    GtkWidget *vboxTargets;

    //GtkWidget *chkActionnote;
    GtkWidget *lblActionnote;
    GtkWidget *ntryActionnote;
    GtkWidget *vboxActionnote;

    //GtkWidget *chkQuitreply;
    GtkWidget *lblQuitreply;
    GtkWidget *ntryQuitreply;
    GtkWidget *vboxQuitreply;

    GtkWidget *lblListWidgetLabel;
    GtkWidget *lblListWidgetCaption;
    GtkWidget *ntryListWidgetLabel;
    GtkWidget *ntryListWidgetCaption;
    GtkWidget *vboxListWidgetThinks;

    GtkWidget *lblDialogCaption;
    GtkWidget *lblDialogLabel;
    GtkWidget *ntryDialogCaption;
    GtkWidget *ntryDialogLabel;
    GtkWidget *vboxDialog;

    GtkWidget *Separator1;

    GtkWidget *vboxMain;
    GtkWidget *hboxMain;

    GtkListStore *listStore;
    GtkWidget *listView;
    GtkWidget *ScrollWindow;

    int iSaved;     //0=not saved, 1=saved

    struct _UserCommandList *userCommandListItem;

};


enum {
	COL_USRCMD_TYPE = 0,
	COL_USRCMD_TEXT,
	COL_USRCMD_VARID,
	COL_USRCMD_PREDEFINE,
	COL_USRCMD_TRUEVALUE,
	COL_USRCMD_FALSEVALUE,
	COL_USRCMD_BUTTONTEXT,
	COL_USRCMD_DIALOGCAPTION,
	COL_USRCMD_NUM_COLS
};

#define CREATEUSRCMND_COLNAMES  {"Type","Text","VarID","Predefine","TrueValue","FalseValue","ButtonText","DialogCaption"/*,"Position" */}

#define CREATEUSRCMD_COLTYPES   G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING/*, G_TYPE_INT*/


void createUserCommand_ButtonCloseDialog (GtkButton *button, struct _CreateUsercommandDialogElements *ElementStruct);
int createUserCommand_createCommandText (GString *gstrCommandText, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_ButtonCreateDialog (GtkButton *button, struct _CreateUsercommandDialogElements *ElementStruct);
int createUserCommand_createDialogEntities(struct _CreateUsercommandDialogElements *ElementStruct, GtkWindow *Parent);
int createUserCommand_arrangeDialogEntities(struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_endMainWidget ( GtkObject *object , struct _CreateUsercommandDialogElements *data);
void createUserCommand_addQuestion(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
int createUserCommand_addItem (const char *cpType, GtkTreeIter *iter, struct _CreateUsercommandDialogElements *ElementStruct );
void createUserCommand_addQuestion(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_addFilechooser(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_addDirchooser(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_addText(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_addSeparator(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_addCheckbox(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
gboolean createUserCommand_ContextMenuOnListView(GtkWidget *treeview, GdkEventButton *event, struct _CreateUsercommandDialogElements *ElementStruct);
gboolean createUserCommand_oneMouseButtonPressedInView(GtkWidget *treeview, GdkEventButton *event, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_editItem (GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_deleteItem (GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct);
gboolean createUserCommand_oneKeyPressedInView(GtkWidget *widget, GdkEventKey *event, struct _CreateUsercommandDialogElements *ElementStruct);
gboolean createUserCommand_ListStoreToUsercommand (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, void *data);
void createUserCommand_ButtonChange (GtkButton *button, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_ButtonAdd (GtkButton *button, struct _CreateUsercommandDialogElements *ElementStruct);
gboolean createUserCommand_ListStoreToUsercommandItems (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, struct _UserCommandList *userCommandListItem);
int createUserCommand_createUsercommandListElement (struct _UserCommandList *userCommandListItem, struct _CreateUsercommandDialogElements *ElementStruct);
int createUserCommand_fillDialogEntities(struct _UserCommandList *userCommandListItem, struct _CreateUsercommandDialogElements *ElementStruct);
void createUserCommand_RowActivated (GtkTreeView *tree_view, GtkTreePath *path, GtkTreeViewColumn *column, struct _CreateUsercommandDialogElements *ElementStruct);
gboolean createUserCommand_oneKeyPressedInMainWidget(GtkWidget *widget, GdkEventKey *event, struct _CreateUsercommandDialogElements *ElementStruct);





GtkWidget *createUserCommand_start (struct _UserCommandList *userCommandListItem, GtkWindow *Parent){
    //this is our main entry function for our dialog which helps us to
    //create usercommands for the xml config file
    TRACEIT (10, "createUserCommand_start       start");
    struct _CreateUsercommandDialogElements *ElementStruct;
    ElementStruct = malloc (sizeof (struct _CreateUsercommandDialogElements));

    if (ElementStruct == NULL){
        TRACEIT (2 ,"createUserCommand_start        unable to allocate memory");
        return NULL;
    }
    ElementStruct->iSaved = 1;  //1 = saved
    ElementStruct->mainWidget = NULL;
    ElementStruct->btnChange = NULL;
    ElementStruct->btnAdd = NULL;
    ElementStruct->btnCreate    = NULL;
    ElementStruct->btnClose    = NULL;
    ElementStruct->hboxBtnBox    = NULL;
    ElementStruct->lblCommand    = NULL;
    ElementStruct->ntryCommand    = NULL;
    ElementStruct->vboxCmndBox    = NULL;
    ElementStruct->chkIsDefaultCommand    = NULL;
    ElementStruct->lblCalltype    = NULL;
    ElementStruct->cmbCalltype    = NULL;
    ElementStruct->hboxCalltype    = NULL;
    ElementStruct->lblTargets    = NULL;
    ElementStruct->ntryTargets    = NULL;
    ElementStruct->vboxTargets    = NULL;
    ElementStruct->lblActionnote    = NULL;
    ElementStruct->ntryActionnote    = NULL;
    ElementStruct->vboxActionnote    = NULL;
    ElementStruct->lblQuitreply    = NULL;
    ElementStruct->ntryQuitreply    = NULL;
    ElementStruct->vboxQuitreply    = NULL;
    ElementStruct->lblListWidgetLabel= NULL;
    ElementStruct->lblListWidgetCaption= NULL;
    ElementStruct->ntryListWidgetLabel= NULL;
    ElementStruct->ntryListWidgetCaption= NULL;
    ElementStruct->vboxListWidgetThinks= NULL;

    ElementStruct->lblDialogCaption= NULL;
    ElementStruct->lblDialogLabel= NULL;
    ElementStruct->ntryDialogCaption= NULL;
    ElementStruct->ntryDialogLabel= NULL;
    ElementStruct->vboxDialog=NULL;

    ElementStruct->Separator1    = NULL;
    ElementStruct->vboxMain    = NULL;
    ElementStruct->hboxMain    = NULL;
    ElementStruct->listStore   = NULL;
    ElementStruct->listView    = NULL;
    ElementStruct->ScrollWindow= NULL;

    ElementStruct->lblName=NULL;
    ElementStruct->ntryName=NULL;
    ElementStruct->vboxName=NULL;
    ElementStruct->userCommandListItem = userCommandListItem;

    createUserCommand_createDialogEntities(ElementStruct, Parent);
    createUserCommand_arrangeDialogEntities(ElementStruct);
    if (userCommandListItem != NULL){
        createUserCommand_fillDialogEntities(userCommandListItem, ElementStruct);
    }

    g_signal_connect(ElementStruct->btnChange,"clicked",G_CALLBACK(createUserCommand_ButtonChange), (void *)ElementStruct);
    g_signal_connect(ElementStruct->btnAdd,"clicked",G_CALLBACK(createUserCommand_ButtonAdd), (void *)ElementStruct);
    g_signal_connect(ElementStruct->btnClose,"clicked",G_CALLBACK(createUserCommand_ButtonCloseDialog), (void *)ElementStruct);
    g_signal_connect(ElementStruct->btnCreate,"clicked",G_CALLBACK(createUserCommand_ButtonCreateDialog), (void *)ElementStruct);

    g_signal_connect (ElementStruct->listView, "button-press-event",G_CALLBACK(createUserCommand_oneMouseButtonPressedInView), ElementStruct);
    g_signal_connect (ElementStruct->listView, "row-activated",G_CALLBACK(createUserCommand_RowActivated), ElementStruct);
    g_signal_connect (ElementStruct->listView,"key-press-event",G_CALLBACK(createUserCommand_oneKeyPressedInView),ElementStruct);

    g_signal_connect (ElementStruct->mainWidget, "key-press-event", G_CALLBACK(createUserCommand_oneKeyPressedInMainWidget),(void *)ElementStruct);
    g_signal_connect (ElementStruct->mainWidget, "destroy", G_CALLBACK(createUserCommand_endMainWidget),(void *)ElementStruct);

    gtk_widget_show_all (ElementStruct->mainWidget);

    if (userCommandListItem == NULL){
        gtk_widget_hide (ElementStruct->btnChange);
    }

    TRACEIT (10, "createUserCommand_start       end");
    if (userCommandListItem != NULL){
        return ElementStruct->mainWidget;
    }
    return NULL;
}


void createUserCommand_endMainWidget ( GtkObject *object , struct _CreateUsercommandDialogElements *ElementStruct){
    TRACEIT (10, "createUserCommand_endMainWidget       start");
    if (ElementStruct == NULL){
        TRACEIT (2, "createUserCommand_endMainWidget       paramter NULL");
        return;
    }
    propPage_external_deleteItemFromglistUserCommandWidgets (ElementStruct->mainWidget);

    free (ElementStruct);
    TRACEIT (10, "createUserCommand_endMainWidget       end");
    return;
}


int createUserCommand_createDialogEntities(struct _CreateUsercommandDialogElements *ElementStruct, GtkWindow *Parent){
    TRACEIT (10, "createUserCommand_createDialog       start");

    if (ElementStruct == NULL){
        TRACEIT (4, "createUserCommand_createDialog         ElementStruct NULL");
        return -1;
    }
    int i;

    ElementStruct->mainWidget = CreateMyWindow(DIALOGCAPTION, Parent, -1, -1, TRUE, TRUE, FALSE, NULL, FALSE, TRUE );

    if (ElementStruct->mainWidget == NULL){
        TRACEIT (4, "createUserCommand_createDialog     unable to create new widget");
        return -1;
    }
    //AddMyIconsToWindow((GtkWindow *)ElementStruct->mainWidget);

    ElementStruct->lblName                 = gtk_label_new ("Specify the name:");
    ElementStruct->ntryName                = gtk_entry_new ();
    ElementStruct->vboxName                = gtk_vbox_new  (FALSE, 0);
    ElementStruct->btnAdd                  = gtk_button_new_with_label     ("Add");
    ElementStruct->btnChange               = gtk_button_new_with_label     ("Change");
    ElementStruct->btnCreate               = gtk_button_new_with_label     ("Create XML text");
    ElementStruct->btnClose                = gtk_button_new_with_label     ("Close");
    ElementStruct->hboxBtnBox              = gtk_hbox_new (FALSE, 0);//gtk_hbox_new (FALSE, 0);
    ElementStruct->lblCommand              = gtk_label_new ("Specify the command to call:");
    ElementStruct->ntryCommand             = gtk_entry_new ();
    ElementStruct->vboxCmndBox             = gtk_vbox_new (FALSE, 0);
    ElementStruct->chkIsDefaultCommand     = gtk_check_button_new_with_label ("Define as defaultcommand for the targets");
    ElementStruct->lblCalltype             = gtk_label_new ("Calltype:");
    ElementStruct->cmbCalltype             = gtk_combo_box_new_text (); //combobox
    ElementStruct->hboxCalltype            = gtk_hbox_new  (FALSE, 0);
    ElementStruct->lblTargets              = gtk_label_new ("Define the targets:");
    ElementStruct->ntryTargets             = gtk_entry_new ();
    ElementStruct->vboxTargets             = gtk_vbox_new  (FALSE, 0);
    ElementStruct->lblActionnote           = gtk_label_new ("Define an action note text:");
    ElementStruct->ntryActionnote          = gtk_entry_new ();
    ElementStruct->vboxActionnote          = gtk_vbox_new  (FALSE, 0);
    ElementStruct->lblQuitreply            = gtk_label_new("Define a quit reply text:");
    ElementStruct->ntryQuitreply           = gtk_entry_new ();
    ElementStruct->vboxQuitreply           = gtk_vbox_new  (FALSE, 0);
    ElementStruct->lblListWidgetLabel      = gtk_label_new ("Define the label for the list widget:");
    ElementStruct->lblListWidgetCaption    = gtk_label_new ("Define the caption for the list widget:");
    ElementStruct->ntryListWidgetLabel     = gtk_entry_new ();
    ElementStruct->ntryListWidgetCaption   = gtk_entry_new ();
    ElementStruct->vboxListWidgetThinks    = gtk_vbox_new  (FALSE, 0);

    ElementStruct->lblDialogCaption        = gtk_label_new ("Dialog caption:");
    ElementStruct->lblDialogLabel          = gtk_label_new ("Dialog label:");
    ElementStruct->ntryDialogCaption       = gtk_entry_new ();
    ElementStruct->ntryDialogLabel         = gtk_entry_new ();
    ElementStruct->vboxDialog              = gtk_vbox_new  (FALSE, 0);

    ElementStruct->Separator1              = gtk_hseparator_new();
    ElementStruct->vboxMain                = gtk_vbox_new (FALSE, 0);
    ElementStruct->hboxMain                = gtk_hbox_new (FALSE, 0);

    ElementStruct->listStore               = gtk_list_store_new(COL_USRCMD_NUM_COLS, CREATEUSRCMD_COLTYPES);
    ElementStruct->listView                = gtk_tree_view_new ();
    ElementStruct->ScrollWindow            = gtk_scrolled_window_new (NULL,NULL);

    gtk_tree_view_set_reorderable ((GtkTreeView *)ElementStruct->listView, TRUE );

    gtk_combo_box_append_text ((GtkComboBox *)ElementStruct->cmbCalltype, "all");  //USERCOMMAND_CALLTYPE_ALL
    gtk_combo_box_append_text ((GtkComboBox *)ElementStruct->cmbCalltype, "each");
    gtk_combo_box_append_text ((GtkComboBox *)ElementStruct->cmbCalltype, "list");
    gtk_combo_box_set_active ((GtkComboBox *)ElementStruct->cmbCalltype, 0);

    GtkTreeViewColumn   *col;
	GtkCellRenderer     *renderer;
	char *cppNames[] = CREATEUSRCMND_COLNAMES;
	for (i=0; i<COL_USRCMD_NUM_COLS ;i++){
		col=gtk_tree_view_column_new();

		gtk_tree_view_column_set_resizable(col,TRUE);
		gtk_tree_view_column_set_reorderable(col,TRUE);
		gtk_tree_view_column_set_title(col, cppNames[i]);
		renderer = gtk_cell_renderer_text_new();
		gtk_tree_view_column_pack_start(col, renderer, TRUE);
		gtk_tree_view_column_add_attribute(col,renderer,"text",i);
		gtk_tree_view_append_column(GTK_TREE_VIEW(ElementStruct->listView),col);
	}

    TRACEIT (10, "createUserCommand_createDialog       end");
    return 0;
}


int createUserCommand_arrangeDialogEntities(struct _CreateUsercommandDialogElements *ElementStruct){
    TRACEIT (10, "createUserCommand_arrangeDialogEntities       start");

    if (ElementStruct == NULL){
        TRACEIT (4, "createUserCommand_arrangeDialogEntities         ElementStruct NULL");
        return -1;
    }

    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxName, ElementStruct->lblName, TRUE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxName, ElementStruct->ntryName, TRUE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->hboxBtnBox, ElementStruct->btnAdd, TRUE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->hboxBtnBox, ElementStruct->btnChange, TRUE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->hboxBtnBox, ElementStruct->btnCreate, TRUE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->hboxBtnBox, ElementStruct->btnClose, TRUE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxCmndBox, ElementStruct->lblCommand, TRUE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxCmndBox, ElementStruct->ntryCommand, TRUE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->hboxCalltype, ElementStruct->lblCalltype, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->hboxCalltype, ElementStruct->cmbCalltype, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->hboxCalltype, ElementStruct->chkIsDefaultCommand, FALSE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxTargets, ElementStruct->lblTargets, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxTargets, ElementStruct->ntryTargets, FALSE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxActionnote, ElementStruct->lblActionnote, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxActionnote, ElementStruct->ntryActionnote, FALSE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxQuitreply, ElementStruct->lblQuitreply, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxQuitreply, ElementStruct->ntryQuitreply, FALSE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxListWidgetThinks, ElementStruct->lblListWidgetCaption, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxListWidgetThinks, ElementStruct->ntryListWidgetCaption, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxListWidgetThinks, ElementStruct->lblListWidgetLabel, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxListWidgetThinks, ElementStruct->ntryListWidgetLabel, FALSE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxDialog, ElementStruct->lblDialogCaption, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxDialog, ElementStruct->ntryDialogCaption, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxDialog, ElementStruct->lblDialogLabel, FALSE, FALSE, 0);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxDialog, ElementStruct->ntryDialogLabel, FALSE, FALSE, 0);

    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(ElementStruct->ScrollWindow),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
    gtk_tree_view_set_model (GTK_TREE_VIEW(ElementStruct->listView), GTK_TREE_MODEL(ElementStruct->listStore));
	gtk_container_add(GTK_CONTAINER(ElementStruct->ScrollWindow),ElementStruct->listView);

    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->vboxName, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->vboxCmndBox, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->hboxCalltype, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->vboxTargets, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->vboxActionnote, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->vboxQuitreply, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->vboxListWidgetThinks, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->Separator1, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->vboxDialog, FALSE, FALSE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, ElementStruct->ScrollWindow, TRUE, TRUE, 5);
    gtk_box_pack_start ((GtkBox *)ElementStruct->vboxMain, gtk_hseparator_new(), FALSE, FALSE, 5);
    gtk_box_pack_end ((GtkBox *)ElementStruct->vboxMain, ElementStruct->hboxBtnBox, FALSE, FALSE, 0);

    gtk_box_pack_start ((GtkBox *)ElementStruct->hboxMain, ElementStruct->vboxMain, TRUE, TRUE, 5);

    gtk_container_add ((GtkContainer *)ElementStruct->mainWidget, ElementStruct->hboxMain);

    g_object_unref(ElementStruct->listStore);

    TRACEIT (10, "createUserCommand_arrangeDialogEntities       end");
    return 0;
}


int createUserCommand_fillDialogEntities(struct _UserCommandList *userCommandListItem, struct _CreateUsercommandDialogElements *ElementStruct ){
    if (userCommandListItem == NULL){
        TRACEIT (2, "createUserCommand_fillDialogEntities       parameter NULL");
        return -1;
    }
    GString *gstrBuf = g_string_sized_new (10);
    GList   *glistBuf = NULL;
    GtkTreeIter iter;
    struct _DialogEntityList *DialogEntityListBuf = NULL;

    if (userCommandListItem->gstrName){
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryName, userCommandListItem->gstrName->str);
    }
    if (userCommandListItem->gstrCommand){
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryCommand, userCommandListItem->gstrCommand->str);
    }
    if (userCommandListItem->iIsDefaultCommand == 1){
        gtk_toggle_button_set_active ( (GtkToggleButton *)ElementStruct->chkIsDefaultCommand, TRUE);
    }
    gtk_combo_box_set_active ((GtkComboBox *)ElementStruct->cmbCalltype, userCommandListItem->option_iCallType);
    if (userCommandListItem->glistTargets){
        glistBuf = userCommandListItem->glistTargets;
        g_string_assign (gstrBuf, "");
        while (glistBuf){
            g_string_append (gstrBuf, ((GString *)(glistBuf->data))->str);
            g_string_append (gstrBuf, " ");
            glistBuf = glistBuf->next;
        }
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryTargets, gstrBuf->str);
    }
    if (userCommandListItem->option_gstrActionnote){
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryActionnote, userCommandListItem->option_gstrActionnote->str);
    }
    if (userCommandListItem->option_gstrQuitreply){
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryQuitreply, userCommandListItem->option_gstrQuitreply->str);
    }
    if (userCommandListItem->option_gstrLabel){
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryListWidgetLabel, userCommandListItem->option_gstrLabel->str);
    }
    if (userCommandListItem->option_gstrCaption){
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryListWidgetCaption, userCommandListItem->option_gstrCaption->str);
    }
    if (userCommandListItem->gstrDialogCaption){
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryDialogCaption, userCommandListItem->gstrDialogCaption->str);
    }
    if (userCommandListItem->gstrDialogLabel){
        gtk_entry_set_text ((GtkEntry *)ElementStruct->ntryDialogLabel, userCommandListItem->gstrDialogLabel->str);
    }
    if (userCommandListItem->DialogEntityList){
        DialogEntityListBuf = userCommandListItem->DialogEntityList;
        while (DialogEntityListBuf){
            gtk_list_store_append(ElementStruct->listStore, &iter);
            if (DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_QUESTION)
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_TYPE, XMLTAG_QUESTION, -1);
            else if (DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_CHECKBOX)
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_TYPE, XMLTAG_CHECKBOX, -1);
            else if (DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_TEXT)
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_TYPE, XMLTAG_TEXT, -1);
            else if (DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_FILECHOOSER)
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_TYPE, XMLTAG_FILECHOOSER, -1);
            else if (DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_DIRCHOOSER)
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_TYPE, XMLTAG_DIRCHOOSER, -1);
            else if (DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_SEPARATOR)
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_TYPE, XMLTAG_SEPARATOR, -1);

            if (DialogEntityListBuf->gstrVarIdentifier){
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_VARID, DialogEntityListBuf->gstrVarIdentifier->str, -1);
            }
            if (DialogEntityListBuf->gstrLabel){
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_TEXT, DialogEntityListBuf->gstrLabel->str, -1);
            }
            if (DialogEntityListBuf->gstrPredefine){
                gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_PREDEFINE, DialogEntityListBuf->gstrPredefine->str, -1);
            }
            if (DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_CHECKBOX){
                if (DialogEntityListBuf->gstrAdditional1){
                    gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_TRUEVALUE, DialogEntityListBuf->gstrAdditional1->str, -1);
                }
                if (DialogEntityListBuf->gstrAdditional2){
                    gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_FALSEVALUE, DialogEntityListBuf->gstrAdditional2->str, -1);
                }
            }
            if (DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_FILECHOOSER || DialogEntityListBuf->iType == USERDIALOG_ENTITY_TYPE_DIRCHOOSER ){
                if (DialogEntityListBuf->gstrAdditional1){
                    gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_BUTTONTEXT, DialogEntityListBuf->gstrAdditional1->str, -1);
                }
                if (DialogEntityListBuf->gstrAdditional2){
                    gtk_list_store_set (ElementStruct->listStore, &iter, COL_USRCMD_DIALOGCAPTION, DialogEntityListBuf->gstrAdditional2->str, -1);
                }
            }
            DialogEntityListBuf = DialogEntityListBuf->nextItem;
        }
    }

    g_string_free (gstrBuf, TRUE);
    return 0;
}


void createUserCommand_ButtonCloseDialog (GtkButton *button, struct _CreateUsercommandDialogElements *ElementStruct){
    if (ElementStruct == NULL){
        return;
    }

    int iCloseIt=1;
    if (ElementStruct->iSaved == 0){
        GtkWidget *dialog = CreateMyDialog("Close",(GtkWindow *)ElementStruct->mainWidget,2,"Back",GTK_RESPONSE_REJECT,"Close anyway",GTK_RESPONSE_ACCEPT, NULL, 0,  TRUE);
        GtkWidget *label = gtk_label_new("The changes you have made were not saved.\nDo you really want to close?\nYou will loose all your changes.");
        gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
        gtk_widget_show_all(dialog);
        if (GTK_RESPONSE_ACCEPT != gtk_dialog_run(GTK_DIALOG(dialog))){
            iCloseIt = 0;
        }
        gtk_widget_destroy(dialog);
    }

    if (iCloseIt == 1)
        gtk_widget_destroy (ElementStruct->mainWidget);
}


void createUserCommand_ButtonCreateDialog (GtkButton *button, struct _CreateUsercommandDialogElements *ElementStruct){

    GtkWidget *Widget = CreateMyWindow(DIALOGCAPTION, (GtkWindow *)ElementStruct->mainWidget, 400, 300, TRUE, TRUE, FALSE, NULL, FALSE, TRUE );
    //AddMyIconsToWindow((GtkWindow *)Widget);

    GtkWidget *scrollwidget;
    GtkWidget *label;
    GtkVBox *VBox;
    GtkWidget *TextView;
    GtkTextBuffer *TextBuffer;
    GtkTextIter iter;
    GString *gstrCommandText = g_string_sized_new(10);
    int iRet=0;

    TextBuffer = gtk_text_buffer_new(NULL);
    gtk_text_buffer_get_end_iter (TextBuffer, &iter);

    iRet = createUserCommand_createCommandText (gstrCommandText, ElementStruct);

    if (iRet == 0){
        gtk_text_buffer_insert (TextBuffer, &iter, gstrCommandText->str, -1);
        g_string_free(gstrCommandText, TRUE);
    }
    else{
        MyMessageWidget ((GtkWindow *)ElementStruct->mainWidget, "Error", gstrCommandText->str);
        g_string_free(gstrCommandText, TRUE);
        return;
    }

    TextView = gtk_text_view_new_with_buffer (TextBuffer);
    VBox = g_object_new(GTK_TYPE_VBOX, "spacing", 5, "homogeneous", FALSE, NULL);
    label = gtk_label_new("The text below is the usercommand you defined.\nIt's ready to be copied to the xml config file\nof Cat'sEyE.\nPlease copy it in the Usercommands sectoin.\n");
    gtk_misc_set_alignment ( (GtkMisc *)label, 0.0f, 0.0f);
    gtk_misc_set_padding ( (GtkMisc *)label, 4, 0);
    gtk_label_set_line_wrap ((GtkLabel *)label, TRUE);

    scrollwidget = gtk_scrolled_window_new(NULL,NULL);

    gtk_scrolled_window_add_with_viewport ( (GtkScrolledWindow *)scrollwidget, TextView);
    gtk_container_add((GtkContainer *)VBox,(GtkWidget *)label);
    gtk_box_set_child_packing ((GtkBox *)VBox, (GtkWidget *)label, FALSE, TRUE, 4, GTK_PACK_START);
    gtk_container_add(GTK_CONTAINER(VBox),scrollwidget);

    gtk_container_add((GtkContainer *)Widget,(GtkWidget *)VBox);


	gtk_widget_show_all(Widget);

    //if (g_TextBuffer_CommandHistory){   //I dont know if this is necessary or not
    //   gtk_object_unref (GTK_OBJECT (g_TextBuffer_CommandHistory));
    //}
}


void createUserCommand_ButtonAdd (GtkButton *button, struct _CreateUsercommandDialogElements *ElementStruct){
    if (0 == createUserCommand_createUsercommandListElement (NULL, ElementStruct))
        createUserCommand_ButtonCloseDialog (NULL, ElementStruct);
    return;
}


void createUserCommand_ButtonChange (GtkButton *button, struct _CreateUsercommandDialogElements *ElementStruct){
    if (0 == createUserCommand_createUsercommandListElement (ElementStruct->userCommandListItem, ElementStruct))
        createUserCommand_ButtonCloseDialog (NULL, ElementStruct);
    return;
}


int createUserCommand_createUsercommandListElement (struct _UserCommandList *userCommandListItem, struct _CreateUsercommandDialogElements *ElementStruct){
    //userCommandListItem can be NULL, in this case, we create a new item in g_UserCommandList
    if (ElementStruct == NULL){
        TRACEIT (4, "createUserCommand_createUsercommandListElement         ElementStruct NULL");
        return -1;
    }
    GString *gstrBuf = g_string_sized_new(10);
    GString *gstrBuf2 = g_string_sized_new(10);
    char *cpBuf=NULL;
    const char *ccpBuf = NULL;
    int iRet = 0;
    //first lets check if the minimal needs are fullfilled
    const char *ccpCommand = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryCommand);
    const char *ccpTargets = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryTargets);
    const char *ccpName    = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryName);

    if (ccpCommand == NULL || strlen (ccpCommand) == 0){
        g_string_assign (gstrBuf, "You must define a command string");
        iRet = -1;
    }
    if (ccpTargets == NULL || strlen (ccpTargets) == 0){
        g_string_assign (gstrBuf, "You must define at least one target");
        iRet = -1;
    }
    if (ccpName == NULL || strlen (ccpName) == 0){
        g_string_assign (gstrBuf, "You must define a name (which is displayed in the context menu");
        iRet = -1;
    }
    if (iRet != 0){
        MyMessageWidget ((GtkWindow *)ElementStruct->mainWidget, "Error", gstrBuf->str);
    }

    //all right, lets create the item
    if (iRet == 0 && userCommandListItem == NULL){
        if ( 0 != UserCommandList_addItem(&g_UserCommandList, "createUserCommand_createUsercommandListElement") ){
            //MyMessageWidget (ElementStruct->mainWidget, "Erro
            TRACEIT (3, "createUserCommand_createUsercommandListElement         error adding item to UserCommandList");
            iRet = -1;
        }
        else {
            userCommandListItem = UserCommandList_getLastItem (g_UserCommandList);
        }
    }
    if (iRet==0 && userCommandListItem == NULL){
        TRACEIT (3, "createUserCommand_createUsercommandListElement         error, no usercommandlist element specified");
        iRet = -1;
    }

    if (iRet==0) {
        //userCommandListItem->iValid = 1;  //validation at the end of the function
        //Name, Command
        UserCommandList_editItem(userCommandListItem, -1, ccpName, NULL, ccpCommand, -1, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        //Targets
        g_string_assign (gstrBuf2, ccpTargets);
        UserCommandList_clearTargets (userCommandListItem);
        for (cpBuf=strtok(gstrBuf2->str, " ") ; cpBuf!=NULL ; cpBuf=strtok(NULL, " ")){
            UserCommandList_editItem(userCommandListItem, -1, NULL, cpBuf, NULL, -1, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        }
        //DefaultCommand
        if (gtk_toggle_button_get_active ( (GtkToggleButton *)ElementStruct->chkIsDefaultCommand)){
            UserCommandList_editItem(userCommandListItem, 1, NULL, NULL, NULL, -1, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        }
        else{
            UserCommandList_editItem(userCommandListItem, 0, NULL, NULL, NULL, -1, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        }
        //Actionnote
        ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryActionnote);
        if (ccpBuf != NULL && strlen(ccpBuf) > 0){
            UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, -1, NULL, ccpBuf, NULL, NULL, NULL, NULL, NULL);
        }
        else{
            UserCommandList_deleteItemElement(userCommandListItem, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0);
        }
        //Quitreply
        ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryQuitreply);
        if (ccpBuf != NULL && strlen(ccpBuf) > 0){
             UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, -1, ccpBuf, NULL, NULL, NULL, NULL, NULL, NULL);
        }
        else{
            UserCommandList_deleteItemElement(userCommandListItem, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0);
        }
        //Calltype
        cpBuf = gtk_combo_box_get_active_text ((GtkComboBox *)ElementStruct->cmbCalltype);
        if (0==strcmp(cpBuf, "all") || 0==strcmp(cpBuf, "All") || 0==strcmp(cpBuf, "ALL")){
            UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, USERCOMMAND_CALLTYPE_ALL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        }
        else if (0==strcmp(cpBuf, "each") || 0==strcmp(cpBuf, "Each") || 0==strcmp(cpBuf, "EACH")){
            UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, USERCOMMAND_CALLTYPE_EACH, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        }
        else if (0==strcmp(cpBuf, "list") || 0==strcmp(cpBuf, "List") || 0==strcmp(cpBuf, "List")){
            UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, USERCOMMAND_CALLTYPE_LIST, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
        }
        //listWidgets label
        ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryListWidgetLabel);
        if (ccpBuf != NULL  && strlen(ccpBuf) > 0){
            UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, -1, NULL, NULL, NULL, ccpBuf, NULL, NULL, NULL);
        }
        else{
            UserCommandList_deleteItemElement(userCommandListItem, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0);
        }
         //listWidgets caption
        ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryListWidgetCaption);
        if (ccpBuf != NULL && strlen(ccpBuf) > 0){
            UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, -1, NULL, NULL, ccpBuf, NULL, NULL, NULL, NULL);
        }
        else{
            UserCommandList_deleteItemElement(userCommandListItem, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0);
        }
        //Dialog caption
        ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryDialogCaption);
        if (ccpBuf != NULL && strlen(ccpBuf) > 0){
            UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, -1, NULL, NULL, NULL, NULL, ccpBuf, NULL, NULL);
        }
        else{
            UserCommandList_deleteItemElement(userCommandListItem, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0);
        }
        //Dialog label
        ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryDialogLabel);
        if (ccpBuf != NULL && strlen(ccpBuf) > 0){
            UserCommandList_editItem(userCommandListItem, -1, NULL, NULL, NULL, -1, NULL, NULL, NULL, NULL, NULL, ccpBuf, NULL);
        }
        else{
            UserCommandList_deleteItemElement(userCommandListItem, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0);
        }

        //first, let us delete the dialogentities in the usercommandlist
        if (userCommandListItem->DialogEntityList != NULL){
            DialogEntityList_freeList(&(userCommandListItem->DialogEntityList));
        }

        gtk_tree_model_foreach(GTK_TREE_MODEL(ElementStruct->listStore),(GtkTreeModelForeachFunc) createUserCommand_ListStoreToUsercommandItems,(void *)userCommandListItem);

        configFileHandling_validateUsercommandList(TRUE); //true or false, it doesnt matter in this version

        propPage_external_fillPropPageWidgets ();
        ElementStruct->iSaved = 1;
    }

    g_string_free(gstrBuf, TRUE);
    g_string_free(gstrBuf2, TRUE);
    return iRet;
}


gboolean    createUserCommand_ListStoreToUsercommandItems (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, struct _UserCommandList *userCommandListItem){
    TRACEIT(10, "createUserCommand_ListStoreToUsercommandItems       start");
    if (userCommandListItem == NULL){
        TRACEIT(2, "createUserCommand_ListStoreToUsercommandItems       parameter NULL");
        return FALSE;
    }

    char *cpType=NULL;
    char *cpText=NULL;
    char *cpVarID=NULL;
    char *cpPredefine=NULL;
    char *cpTrueValue=NULL;
    char *cpFalseValue=NULL;
    char *cpButtonText=NULL;
    char *cpDailogCaption=NULL;

    int iItemAdded = 0; //becomes 1 if an item was added to the list

    gtk_tree_model_get(model, iter, COL_USRCMD_TYPE, &cpType, -1);

    if (strcmp (cpType, XMLTAG_QUESTION) == 0){
        if (0 == DialogEntityList_addItem(&(userCommandListItem->DialogEntityList), USERDIALOG_ENTITY_TYPE_QUESTION)){
            iItemAdded = 1;
            gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_VARID, &cpVarID, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_PREDEFINE, &cpPredefine, -1);
        }
    }
    else if (strcmp (cpType, XMLTAG_CHECKBOX) == 0){
        if (0 == DialogEntityList_addItem(&(userCommandListItem->DialogEntityList), USERDIALOG_ENTITY_TYPE_CHECKBOX)){
            iItemAdded = 1;
            gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_VARID, &cpVarID, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_PREDEFINE, &cpPredefine, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_TRUEVALUE, &cpTrueValue, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_FALSEVALUE, &cpFalseValue, -1);
        }
    }
    else if (strcmp (cpType, XMLTAG_TEXT) == 0){
         if (0 == DialogEntityList_addItem(&(userCommandListItem->DialogEntityList), USERDIALOG_ENTITY_TYPE_TEXT)){
            iItemAdded = 1;
            gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
         }
    }
    else if (strcmp (cpType, XMLTAG_FILECHOOSER) == 0 ){
        if (0 == DialogEntityList_addItem(&(userCommandListItem->DialogEntityList), USERDIALOG_ENTITY_TYPE_FILECHOOSER)){
            iItemAdded = 1;
            gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_VARID, &cpVarID, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_PREDEFINE, &cpPredefine, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_BUTTONTEXT, &cpButtonText, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_DIALOGCAPTION, &cpDailogCaption, -1);
        }
    }
    else if (strcmp (cpType, XMLTAG_DIRCHOOSER) == 0){
        if (0 == DialogEntityList_addItem(&(userCommandListItem->DialogEntityList), USERDIALOG_ENTITY_TYPE_DIRCHOOSER)){
            iItemAdded = 1;
            gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_VARID, &cpVarID, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_PREDEFINE, &cpPredefine, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_BUTTONTEXT, &cpButtonText, -1);
            gtk_tree_model_get(model, iter, COL_USRCMD_DIALOGCAPTION, &cpDailogCaption, -1);
        }
    }
    else if (strcmp (cpType, XMLTAG_SEPARATOR) == 0){
         if (0 == DialogEntityList_addItem(&(userCommandListItem->DialogEntityList), USERDIALOG_ENTITY_TYPE_SEPARATOR)){
            iItemAdded = 1;
         }
    }

    if (iItemAdded == 1){
        if (cpText && 0 < strlen (cpText)){
            DialogEntityList_editLastItem(userCommandListItem->DialogEntityList, -1, NULL, cpText, NULL, NULL, NULL, NULL, NULL, NULL );
        }
        if (cpVarID && 0 < strlen (cpVarID)){
            DialogEntityList_editLastItem(userCommandListItem->DialogEntityList, -1, cpVarID, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
        }
        if (cpPredefine && 0 < strlen (cpPredefine)){
            DialogEntityList_editLastItem(userCommandListItem->DialogEntityList, -1, NULL, NULL, NULL, cpPredefine, NULL, NULL, NULL, NULL );
        }
        if (cpTrueValue && 0 < strlen (cpTrueValue)){
            DialogEntityList_editLastItem(userCommandListItem->DialogEntityList, -1, NULL, NULL, NULL, NULL, NULL, cpTrueValue, NULL, NULL );
        }
        if (cpFalseValue && 0 < strlen (cpFalseValue)){
            DialogEntityList_editLastItem(userCommandListItem->DialogEntityList, -1, NULL, NULL, NULL, NULL, NULL, NULL, cpFalseValue, NULL );
        }
        if (cpButtonText && 0 < strlen (cpButtonText)){
            DialogEntityList_editLastItem(userCommandListItem->DialogEntityList, -1, NULL, NULL, NULL, NULL, NULL, cpButtonText, NULL, NULL );
        }
        if (cpDailogCaption && 0 < strlen (cpDailogCaption)){
            DialogEntityList_editLastItem(userCommandListItem->DialogEntityList, -1, NULL, NULL, NULL, NULL, NULL, NULL, cpDailogCaption, NULL );
        }
    }

    if (cpType)
        g_free(cpType);
    if (cpText)
        g_free(cpText);
    if (cpVarID)
        g_free(cpVarID);
    if (cpPredefine)
        g_free(cpPredefine);
    if (cpTrueValue)
        g_free(cpTrueValue);
    if (cpFalseValue)
        g_free(cpFalseValue);
    if (cpButtonText)
        g_free(cpButtonText);
    if (cpDailogCaption)
        g_free(cpDailogCaption);

    TRACEIT(10, "createUserCommand_ListStoreToUsercommandItems       end");
    return FALSE;
}


int createUserCommand_createCommandText (GString *gstrCommandText, struct _CreateUsercommandDialogElements *ElementStruct){
    //will fill gstrCommandText with text which can simply be draged to the xml configfile
    //on error, gstrCommandText will hold the error text
    //return: 0=ok, -1=error (gstrCommandText is set with errormessage);
    TRACEIT (10, "createUserCommand_createCommandText       start");

    if (ElementStruct == NULL){
        TRACEIT (4, "createUserCommand_createCommandText         ElementStruct NULL");
        return -1;
    }

    if (gstrCommandText == NULL){
        TRACEIT (4, "createUserCommand_createCommandText         Parameter NULL");
        return -1;
    }

    //first lets check if the minimal needs are fullfilled
    const char *ccpCommand = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryCommand);
    const char *ccpTargets = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryTargets);
    const char *ccpName    = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryName);

    if (ccpCommand == NULL || strlen (ccpCommand) == 0){
        g_string_assign (gstrCommandText, "You must define a command string");
        return -1;
    }
    if (ccpTargets == NULL || strlen (ccpTargets) == 0){
        g_string_assign (gstrCommandText, "You must define at least one target");
        return -1;
    }
    if (ccpName == NULL || strlen (ccpName) == 0){
        g_string_assign (gstrCommandText, "You must define a name (which is displayed in the context menu");
        return -1;
    }

    GString *gstrBuf = g_string_sized_new(10);
    GString *gstrBuf2 = g_string_sized_new(10);
    char *cpBuf = NULL;
    const char *ccpBuf = NULL;

    g_string_printf (gstrCommandText, "<%s>",XMLTAG_USERCOMMAND);
    g_string_append(gstrCommandText, "\n");
    //Name
    createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_NAME, NULL, ccpName);

    //Command
    createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_COMMAND, NULL, ccpCommand);

    g_string_append(gstrCommandText, "\n");
    //Targets
    g_string_assign (gstrBuf2, ccpTargets);
    for (cpBuf=strtok(gstrBuf2->str, " ") ; cpBuf!=NULL ; cpBuf=strtok(NULL, " ")){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_TARGET, NULL, cpBuf);
        //g_string_append (gstrCommandText, gstrBuf->str);
        g_string_append(gstrCommandText, "\n");
    }
    //DefaultCommand
    if (gtk_toggle_button_get_active ( (GtkToggleButton *)ElementStruct->chkIsDefaultCommand)){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_DEFAULTCOMMAND, NULL, "true");
        //g_string_append (gstrCommandText, gstrBuf->str);
        g_string_append(gstrCommandText, "\n");
    }
    //Actionnote
    //if (gtk_toggle_button_get_active ( (GtkToggleButton *)ElementStruct->chkActionnote)){
    ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryActionnote);
    if (ccpBuf != NULL && strlen(ccpBuf) > 0){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_ACTIONNOTE, NULL, ccpBuf);
        //g_string_append (gstrCommandText, gstrBuf->str);
        g_string_append(gstrCommandText, "\n");
    }
    //}
    //Quitreply
    //if (gtk_toggle_button_get_active ( (GtkToggleButton *)ElementStruct->chkQuitreply)){
    ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryQuitreply);
    if (ccpBuf != NULL && strlen(ccpBuf) > 0){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_QUITREPLY, NULL, ccpBuf);
        //g_string_append (gstrCommandText, gstrBuf->str);
        g_string_append(gstrCommandText, "\n");
    }
    //}
    //Calltype
    cpBuf = gtk_combo_box_get_active_text ((GtkComboBox *)ElementStruct->cmbCalltype);
    createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_CALLTYPE, NULL, cpBuf);
    //g_string_append (gstrCommandText, gstrBuf->str);
    g_string_append(gstrCommandText, "\n");
    //listWidgets label
    ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryListWidgetLabel);
    if (ccpBuf != NULL  && strlen(ccpBuf) > 0){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_LISTLABEL, NULL, ccpBuf);
        //g_string_append (gstrCommandText, gstrBuf->str);
        g_string_append(gstrCommandText, "\n");
    }
    //listWidgets caption
    ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryListWidgetCaption);
    if (ccpBuf != NULL && strlen(ccpBuf) > 0){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_LISTCAPTION, NULL, ccpBuf);
        //g_string_append (gstrCommandText, gstrBuf->str);
        g_string_append(gstrCommandText, "\n");
    }
    //Dialog caption
    ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryDialogCaption);
    if (ccpBuf != NULL && strlen(ccpBuf) > 0){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_DIALOGCAPTION, NULL, ccpBuf);
        //g_string_append (gstrCommandText, gstrBuf->str);
        g_string_append(gstrCommandText, "\n");
    }
    //Dialog label
    ccpBuf = gtk_entry_get_text ((GtkEntry *)ElementStruct->ntryDialogLabel);
    if (ccpBuf != NULL && strlen(ccpBuf) > 0){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_DIALOGLABEL, NULL, ccpBuf);
        //g_string_append (gstrCommandText, gstrBuf->str);
        g_string_append(gstrCommandText, "\n");
    }


    gtk_tree_model_foreach(GTK_TREE_MODEL(ElementStruct->listStore),(GtkTreeModelForeachFunc) createUserCommand_ListStoreToUsercommand,(void *)gstrCommandText);
    g_string_append(gstrCommandText, "\n");


    g_string_append_printf (gstrCommandText, "</%s>",XMLTAG_USERCOMMAND);

    g_string_free (gstrBuf, TRUE);
    g_string_free (gstrBuf2, TRUE);
    TRACEIT (10, "createUserCommand_createCommandText       end");
    return 0;
}


gboolean createUserCommand_ListStoreToUsercommand (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, void *data){
    TRACEIT(10, "createUserCommand_ListStoreToUsercommand       start");
    if (data == NULL){
        TRACEIT(2, "createUserCommand_ListStoreToUsercommand       parameter NULL");
        return FALSE;
    }
    GString *gstrCommandText = (GString *)data;

    char *cpType=NULL;
    char *cpText=NULL;
    char *cpVarID=NULL;
    char *cpPredefine=NULL;
    char *cpTrueValue=NULL;
    char *cpFalseValue=NULL;
    char *cpButtonText=NULL;
    char *cpDailogCaption=NULL;

    gtk_tree_model_get(model, iter, COL_USRCMD_TYPE, &cpType, -1);

    if (strcmp (cpType, XMLTAG_QUESTION) == 0){
        gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_VARID, &cpVarID, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_PREDEFINE, &cpPredefine, -1);
    }
    else if (strcmp (cpType, XMLTAG_CHECKBOX) == 0){
        gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_VARID, &cpVarID, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_PREDEFINE, &cpPredefine, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_TRUEVALUE, &cpTrueValue, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_FALSEVALUE, &cpFalseValue, -1);
    }
    else if (strcmp (cpType, XMLTAG_TEXT) == 0){
        gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
    }
    else if (strcmp (cpType, XMLTAG_FILECHOOSER) == 0 || strcmp (cpType, XMLTAG_DIRCHOOSER) == 0){
        gtk_tree_model_get(model, iter, COL_USRCMD_TEXT, &cpText, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_VARID, &cpVarID, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_PREDEFINE, &cpPredefine, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_BUTTONTEXT, &cpButtonText, -1);
        gtk_tree_model_get(model, iter, COL_USRCMD_DIALOGCAPTION, &cpDailogCaption, -1);
    }
    //XMLTAG_SEPARATOR separator has no further info for us

    g_string_append_printf (gstrCommandText, "<%s type=\"%s\">",XMLTAG_OBJECT,cpType);
    g_string_append(gstrCommandText, "\n");
    if (cpText){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_LABELTEXT, NULL, cpText );
        g_string_append(gstrCommandText, "\n");
    }
    if (cpVarID){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_VARID, NULL, cpVarID );
        g_string_append(gstrCommandText, "\n");
    }
    if (cpPredefine){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_PREDEFINE, NULL, cpPredefine );
        g_string_append(gstrCommandText, "\n");
    }
    if (cpTrueValue){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_TRUEVALUE, NULL, cpTrueValue );
        g_string_append(gstrCommandText, "\n");
    }
    if (cpFalseValue){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_FALSEVALUE, NULL, cpFalseValue );
        g_string_append(gstrCommandText, "\n");
    }
    if (cpButtonText){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_BUTTONTEXT, NULL, cpButtonText );
        g_string_append(gstrCommandText, "\n");
    }
    if (cpDailogCaption){
        createUserCommand_createXMLOptionString (gstrCommandText, XMLTAG_CHOOSERCAPTION, NULL, cpDailogCaption );
        g_string_append(gstrCommandText, "\n");
    }
    g_string_append_printf (gstrCommandText, "</%s>",XMLTAG_OBJECT);

    if (cpType)
        g_free(cpType);
    if (cpText)
        g_free(cpText);
    if (cpVarID)
        g_free(cpVarID);
    if (cpPredefine)
        g_free(cpPredefine);
    if (cpTrueValue)
        g_free(cpTrueValue);
    if (cpFalseValue)
        g_free(cpFalseValue);
    if (cpButtonText)
        g_free(cpButtonText);
    if (cpDailogCaption)
        g_free(cpDailogCaption);

    TRACEIT(10, "createUserCommand_ListStoreToUsercommand       end");
    return FALSE;
}



int createUserCommand_createXMLOptionString (GString *gstrDestination, const char *ccpID, const char *ccpName, const char *ccpValue ){
    //this creates a option sectoin filled with ID Name and Value
    //at least one of ID Name or Value must be valid to create an option section
    //return 0=ok, -1=error
    TRACEIT (10, "createUserCommand_createXMLOptionString       start");
    if (gstrDestination == NULL){
        TRACEIT (2, "createUserCommand_createXMLOptionString       Parameter NULL");
        return -1;
    }
    if (ccpID==NULL && ccpName==NULL && ccpValue==NULL){
        TRACEIT (2, "createUserCommand_createXMLOptionString       Parameter 2 NULL");
        return -1;
    }

    GString *gstrBuf = g_string_sized_new (10);

    g_string_append_printf (gstrDestination, "<%s>", XMLTAG_OPTION);
    if (ccpID != NULL){
        g_string_append_printf (gstrDestination, "<%s>%s</%s>",XMLTAG_ID,ccpID,XMLTAG_ID);
    }
    if (ccpName != NULL){
        g_string_assign (gstrBuf, ccpName);
        ExchangeSpecialCharachterForXML (gstrBuf);
        g_string_append_printf (gstrDestination, "<%s>%s</%s>",XMLTAG_NAME,gstrBuf->str,XMLTAG_NAME);
    }
    if (ccpValue != NULL){
        g_string_assign (gstrBuf, ccpValue);
        ExchangeSpecialCharachterForXML (gstrBuf);
        g_string_append_printf (gstrDestination, "<%s>%s</%s>",XMLTAG_VALUE,gstrBuf->str,XMLTAG_VALUE);
    }
    g_string_append_printf (gstrDestination, "</%s>", XMLTAG_OPTION);

    g_string_free (gstrBuf, TRUE);
    TRACEIT (10, "createUserCommand_createXMLOptionString       end");
    return 0;
}


gboolean createUserCommand_oneKeyPressedInMainWidget(GtkWidget *widget, GdkEventKey *event, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_oneKeyPressedInMainWidget		start");
	if (ElementStruct == NULL){
		TRACEIT (2, "createUserCommand_oneKeyPressedInMainWidget			parameter NULL");
		return FALSE;
	}
    ElementStruct->iSaved = 0;

	TRACEIT(10,"createUserCommand_oneKeyPressedInMainWidget		end");
	return FALSE;
}


gboolean createUserCommand_oneKeyPressedInView(GtkWidget *widget, GdkEventKey *event, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_oneKeyPressedInView		start");
	guint modifiers;

	modifiers = gtk_accelerator_get_default_mod_mask ();

    if ( (event->keyval == GDK_Delete)){
	    //Delete selected files with 'del-key'
		createUserCommand_deleteItem (NULL, ElementStruct);
		TRACEIT(10,"createUserCommand_oneKeyPressedInView		ends");
		return TRUE;
	}

	TRACEIT(10,"createUserCommand_oneKeyPressedInView		end");
	return FALSE;
}


gboolean createUserCommand_oneMouseButtonPressedInView(GtkWidget *treeview, GdkEventButton *event, struct _CreateUsercommandDialogElements *ElementStruct){
    TRACEIT(10,"createUserCommand_oneMouseButtonPressedInView		start");
    if (event->type == GDK_BUTTON_PRESS  &&  event->button == 3){
		createUserCommand_ContextMenuOnListView(treeview,event, ElementStruct);
		TRACEIT(10,"createUserCommand_oneMouseButtonPressedInView		end");
		return TRUE;
	}
	TRACEIT(10,"createUserCommand_oneMouseButtonPressedInView		end");
	return FALSE;
}


gboolean createUserCommand_ContextMenuOnListView(GtkWidget *treeview, GdkEventButton *event, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_ContextMenuOnListView		start");

	GtkWidget *menu, *menuitem;
	GtkWidget *sep1, *sep2;// *sep3;
    GtkTreeSelection *selection;
    int iSelectedRows;


	menu = gtk_menu_new();

    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
    iSelectedRows = gtk_tree_selection_count_selected_rows(selection);

    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
	if (iSelectedRows <= 1){   //Event can be NULL if the key for contextmenu is presed
		GtkTreePath *path;
        TRACEIT(11,"openContextMenu		mark the item coverd by mousepointer");
        if (gtk_tree_view_get_path_at_pos(GTK_TREE_VIEW(treeview), (gint) event->x, (gint) event->y, &path, NULL, NULL, NULL)){
			gtk_tree_selection_unselect_all(selection);
			gtk_tree_selection_select_path(selection, path);
			gtk_tree_path_free(path);
		}
	}

    sep1 = gtk_separator_menu_item_new ();
	sep2 = gtk_separator_menu_item_new ();

    menuitem = gtk_menu_item_new_with_label("add question ...");
	g_signal_connect(menuitem,"activate",G_CALLBACK(createUserCommand_addQuestion),ElementStruct);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

	menuitem = gtk_menu_item_new_with_label("add checkbox ...");
	g_signal_connect(menuitem,"activate",G_CALLBACK(createUserCommand_addCheckbox),ElementStruct);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

    menuitem = gtk_menu_item_new_with_label("add text ...");
	g_signal_connect(menuitem,"activate",G_CALLBACK(createUserCommand_addText),ElementStruct);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

    menuitem = gtk_menu_item_new_with_label("add dirchooser ...");
	g_signal_connect(menuitem,"activate",G_CALLBACK(createUserCommand_addDirchooser),ElementStruct);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

    menuitem = gtk_menu_item_new_with_label("add filechooser ...");
	g_signal_connect(menuitem,"activate",G_CALLBACK(createUserCommand_addFilechooser),ElementStruct);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

    menuitem = gtk_menu_item_new_with_label("add separator ...");
	g_signal_connect(menuitem,"activate",G_CALLBACK(createUserCommand_addSeparator),ElementStruct);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);


    gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep1);

    menuitem = gtk_menu_item_new_with_label("edit ...");
	g_signal_connect(menuitem,"activate",G_CALLBACK(createUserCommand_editItem),ElementStruct);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

    gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep2);

    menuitem = gtk_menu_item_new_with_label("delete");
	g_signal_connect(menuitem,"activate",G_CALLBACK(createUserCommand_deleteItem), ElementStruct);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);


    gtk_widget_show_all(menu);
	// Note: event can be NULL here when called from view_onPopupMenu;
	// gdk_event_get_time() accepts a NULL argument
	gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, (event != NULL) ? event->button : 0, gdk_event_get_time((GdkEvent*)event));

	TRACEIT(10,"createUserCommand_ContextMenuOnListView		ends");
	return TRUE;
}


void createUserCommand_RowActivated (GtkTreeView *tree_view, GtkTreePath *path, GtkTreeViewColumn *column, struct _CreateUsercommandDialogElements *ElementStruct){
    TRACEIT(10,"createUserCommand_RowActivated		start");
    createUserCommand_editItem (NULL, ElementStruct);
    TRACEIT(10,"createUserCommand_RowActivated		end");
    return;
}


void createUserCommand_editItem (GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct){
    TRACEIT(10,"createUserCommand_editItem		start");
    GtkTreeModel *model=NULL;
    GtkTreeIter iter;
    GtkTreeSelection	*selection;
    selection  = gtk_tree_view_get_selection((GtkTreeView *)ElementStruct->listView);

    GList *glistPathList = gtk_tree_selection_get_selected_rows (selection, &model);
    GList *glistBuf;

    if (glistPathList == NULL){
        return;
    }

    glistBuf = glistPathList;
    while (glistBuf){
        gtk_tree_model_get_iter(GTK_TREE_MODEL(ElementStruct->listStore), &iter, (GtkTreePath *)glistBuf->data);
        createUserCommand_addItem (NULL, &iter, ElementStruct);
        glistBuf = glistBuf->next;
    }

    g_list_foreach (glistPathList,(GFunc) gtk_tree_path_free, NULL);
    g_list_free (glistPathList);

	TRACEIT(10,"createUserCommand_editItem		end");
	return;
}


void createUserCommand_deleteItem (GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct){
    TRACEIT(10,"createUserCommand_deleteItem		start");
    GtkTreeModel *model=NULL;
    GtkTreeIter iter;
    GtkTreeSelection	*selection;
    selection  = gtk_tree_view_get_selection((GtkTreeView *)ElementStruct->listView);

    GList *glistPathList = gtk_tree_selection_get_selected_rows (selection, &model);
    GList *glistBuf;

    if (glistPathList == NULL){
        return;
    }

    glistBuf = glistPathList;
    while (glistBuf){
        gtk_tree_model_get_iter(GTK_TREE_MODEL(ElementStruct->listStore), &iter, (GtkTreePath *)glistBuf->data);
        gtk_list_store_remove(GTK_LIST_STORE(model), &iter);
        glistBuf = glistBuf->next;
    }
    ElementStruct->iSaved = 0;
    g_list_foreach (glistPathList,(GFunc) gtk_tree_path_free, NULL);
    g_list_free (glistPathList);
    TRACEIT(10,"createUserCommand_deleteItem		end");
    return;
}


void createUserCommand_addQuestion(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_addQuestion		start");
    createUserCommand_addItem (XMLTAG_QUESTION, NULL, ElementStruct);
	TRACEIT(10,"createUserCommand_addQuestion		end");
	return;
}

void createUserCommand_addCheckbox(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_addCheckbox		start");
    createUserCommand_addItem (XMLTAG_CHECKBOX, NULL, ElementStruct);
	TRACEIT(10,"createUserCommand_addCheckbox		end");
	return;
}

void createUserCommand_addText(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_addText		start");
    createUserCommand_addItem (XMLTAG_TEXT, NULL, ElementStruct);
	TRACEIT(10,"createUserCommand_addText		end");
	return;
}

void createUserCommand_addDirchooser(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_addDirchooser		start");
    createUserCommand_addItem (XMLTAG_DIRCHOOSER, NULL, ElementStruct);
	TRACEIT(10,"createUserCommand_addDirchooser		end");
	return;
}

void createUserCommand_addFilechooser(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_addFilechooser		start");
    createUserCommand_addItem (XMLTAG_FILECHOOSER, NULL, ElementStruct);
	TRACEIT(10,"createUserCommand_addFilechooser		end");
	return;
}

void createUserCommand_addSeparator(GtkWidget *menuitem, struct _CreateUsercommandDialogElements *ElementStruct){
	TRACEIT(10,"createUserCommand_addSeparator		start");
    createUserCommand_addItem (XMLTAG_SEPARATOR, NULL, ElementStruct);
	TRACEIT(10,"createUserCommand_addSeparator		end");
	return;
}

int createUserCommand_addItem (const char *cpType, GtkTreeIter *iter, struct _CreateUsercommandDialogElements *ElementStruct ){
    //also used for editing. in this case iter and model have to be defined AND cpType must not be set
    TRACEIT(10,"createUserCommand_addItem		end");

    if (cpType == NULL && (iter == NULL || ElementStruct == NULL) ){
        TRACEIT (2, "createUserCommand_addItem      Parameter NULL");
        return -1;
    }

    GtkWidget *dialog;
    gboolean bUseText = FALSE;
    gboolean bUseVarID = FALSE;
    gboolean bUsePredefine = FALSE;
    gboolean bUseTrueValue = FALSE;
    gboolean bUseFalseValue = FALSE;
    gboolean bUseButtonText = FALSE;
    gboolean bUseDialogCaption = FALSE;
    GtkTreeIter NewIter;

    GtkTreeModel *Model = (GtkTreeModel *)ElementStruct->listStore;

    dialog = CreateMyDialog(DIALOGCAPTION, (GtkWindow *)ElementStruct->mainWidget, 2, "Ok", GTK_RESPONSE_ACCEPT, "Cancel", 1,NULL,0, TRUE);

    GString *gstrBuf = g_string_sized_new (10);
    GString *gstrType = g_string_sized_new (10);
    char *cpBuf = NULL;

    if (cpType != NULL){
        g_string_append (gstrType, cpType);
        iter = &NewIter;
    }
    else{
        gtk_tree_model_get((GtkTreeModel *)ElementStruct->listStore, iter, COL_USRCMD_TYPE, &cpBuf, -1);
        g_string_append (gstrType, cpBuf);
        g_free (cpBuf);
        cpBuf = NULL;
    }

    if (strcmp (gstrType->str, XMLTAG_QUESTION) == 0){
        bUseText = TRUE;
        bUseVarID = TRUE;
        bUsePredefine = TRUE;
    }
    else if (strcmp (gstrType->str, XMLTAG_CHECKBOX) == 0){
        bUseText = TRUE;
        bUseVarID = TRUE;
        bUsePredefine = TRUE;
        bUseTrueValue = TRUE;
        bUseFalseValue = TRUE;
    }
    else if (strcmp (gstrType->str, XMLTAG_TEXT) == 0){
        bUseText = TRUE;
    }
    else if (strcmp (gstrType->str, XMLTAG_FILECHOOSER) == 0){
        bUseText = TRUE;
        bUseVarID = TRUE;
        bUsePredefine = TRUE;
        bUseButtonText = TRUE;
        bUseDialogCaption = TRUE;
    }
    else if (strcmp (gstrType->str, XMLTAG_DIRCHOOSER) == 0){
        bUseText = TRUE;
        bUseVarID = TRUE;
        bUsePredefine = TRUE;
        bUseButtonText = TRUE;
        bUseDialogCaption = TRUE;
    }
    //XMLTAG_SEPARATOR does not need any further information

    g_string_assign (gstrBuf, "Define properties for: ");
    g_string_append (gstrBuf, gstrType->str);

    GtkWidget *lblLabel = gtk_label_new (gstrBuf->str);
    GtkWidget *vboxMain = gtk_vbox_new (FALSE, 0);
    GtkWidget *wdgtText1 = NULL;
    GtkWidget *wdgtVarID1 = NULL;
    GtkWidget *wdgtPredefine1 = NULL;
    GtkWidget *wdgtTrueValue1 = NULL;
    GtkWidget *wdgtFalseValue1 = NULL;
    GtkWidget *wdgtButtonText1 = NULL;
    GtkWidget *wdgtDailogCaption1 = NULL;
    GtkWidget *hBoxBuf = NULL;

    gtk_box_pack_start ((GtkBox *)vboxMain, lblLabel, TRUE, FALSE, 0);

    if (bUseText){
        hBoxBuf = gtk_hbox_new(FALSE, 0);
        wdgtText1 = gtk_label_new ("Text: ");
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtText1, TRUE, FALSE, 0);
        wdgtText1 = gtk_entry_new ();
        if (cpType == NULL){
            gtk_tree_model_get(Model, iter, COL_USRCMD_TEXT, &cpBuf, -1);
            if (cpBuf != NULL){
                gtk_entry_set_text ((GtkEntry *)wdgtText1, cpBuf);
                g_free (cpBuf);
            }
            cpBuf = NULL;
        }
        g_signal_connect (wdgtText1, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtText1, TRUE, FALSE, 0);
        gtk_box_pack_start ((GtkBox *)vboxMain, hBoxBuf, TRUE, FALSE, 0);
    }
    if (bUseVarID){
        hBoxBuf = gtk_hbox_new(FALSE, 0);
        wdgtVarID1 = gtk_label_new ("VarID: ");
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtVarID1, TRUE, FALSE, 0);
        wdgtVarID1 = gtk_entry_new ();
        if (cpType == NULL){
            gtk_tree_model_get(Model, iter, COL_USRCMD_VARID, &cpBuf, -1);
            if (cpBuf != NULL){
                gtk_entry_set_text ((GtkEntry *)wdgtVarID1, cpBuf);
                g_free (cpBuf);
            }
            cpBuf = NULL;
        }
        g_signal_connect (wdgtVarID1, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtVarID1, TRUE, FALSE, 0);
        gtk_box_pack_start ((GtkBox *)vboxMain, hBoxBuf, TRUE, FALSE, 0);
    }
    if (bUsePredefine){
        hBoxBuf = gtk_hbox_new(FALSE, 0);
        wdgtPredefine1 = gtk_label_new ("Predefine: ");
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtPredefine1, TRUE, FALSE, 0);
        wdgtPredefine1 = gtk_entry_new ();
        if (cpType == NULL){
            gtk_tree_model_get(Model, iter, COL_USRCMD_PREDEFINE, &cpBuf, -1);
            if (cpBuf != NULL){
                gtk_entry_set_text ((GtkEntry *)wdgtPredefine1, cpBuf);
                g_free (cpBuf);
            }
            cpBuf = NULL;
        }
        g_signal_connect (wdgtPredefine1, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtPredefine1, TRUE, FALSE, 0);
        gtk_box_pack_start ((GtkBox *)vboxMain, hBoxBuf, TRUE, FALSE, 0);
    }
    if (bUseTrueValue){
        hBoxBuf = gtk_hbox_new(FALSE, 0);
        wdgtTrueValue1 = gtk_label_new ("True Value: ");
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtTrueValue1, TRUE, FALSE, 0);
        wdgtTrueValue1 = gtk_entry_new ();
        if (cpType == NULL){
            gtk_tree_model_get(Model, iter, COL_USRCMD_TRUEVALUE, &cpBuf, -1);
            if (cpBuf != NULL){
                gtk_entry_set_text ((GtkEntry *)wdgtTrueValue1, cpBuf);
                g_free (cpBuf);
            }
            cpBuf = NULL;
        }
        g_signal_connect (wdgtTrueValue1, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtTrueValue1, TRUE, FALSE, 0);
        gtk_box_pack_start ((GtkBox *)vboxMain, hBoxBuf, TRUE, FALSE, 0);
    }
    if (bUseFalseValue){
        hBoxBuf = gtk_hbox_new(FALSE, 0);
        wdgtFalseValue1 = gtk_label_new ("False Value: ");
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtFalseValue1, TRUE, FALSE, 0);
        wdgtFalseValue1 = gtk_entry_new ();
        if (cpType == NULL){
            gtk_tree_model_get(Model, iter, COL_USRCMD_FALSEVALUE, &cpBuf, -1);
            if (cpBuf != NULL){
                gtk_entry_set_text ((GtkEntry *)wdgtFalseValue1, cpBuf);
                g_free (cpBuf);
            }
            cpBuf = NULL;
        }
        g_signal_connect (wdgtFalseValue1, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtFalseValue1, TRUE, FALSE, 0);
        gtk_box_pack_start ((GtkBox *)vboxMain, hBoxBuf, TRUE, FALSE, 0);
    }
    if (bUseButtonText){
        hBoxBuf = gtk_hbox_new(FALSE, 0);
        wdgtButtonText1 = gtk_label_new ("Button Text: ");
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtButtonText1, TRUE, FALSE, 0);
        wdgtButtonText1 = gtk_entry_new ();
        if (cpType == NULL){
            gtk_tree_model_get(Model, iter, COL_USRCMD_BUTTONTEXT, &cpBuf, -1);
            if (cpBuf != NULL){
                gtk_entry_set_text ((GtkEntry *)wdgtButtonText1, cpBuf);
                g_free (cpBuf);
            }
            cpBuf = NULL;
        }
        g_signal_connect (wdgtButtonText1, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtButtonText1, TRUE, FALSE, 0);
        gtk_box_pack_start ((GtkBox *)vboxMain, hBoxBuf, TRUE, FALSE, 0);
    }
    if (bUseDialogCaption){
        hBoxBuf = gtk_hbox_new(FALSE, 0);
        wdgtDailogCaption1 = gtk_label_new ("Dialog Caption: ");
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtDailogCaption1, TRUE, FALSE, 0);
        wdgtDailogCaption1 = gtk_entry_new ();
        if (cpType == NULL){
            gtk_tree_model_get(Model, iter, COL_USRCMD_DIALOGCAPTION, &cpBuf, -1);
            if (cpBuf != NULL){
                gtk_entry_set_text ((GtkEntry *)wdgtDailogCaption1, cpBuf);
                g_free (cpBuf);
            }
            cpBuf = NULL;
        }
        g_signal_connect (wdgtDailogCaption1, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
        gtk_box_pack_start ((GtkBox *)hBoxBuf, wdgtDailogCaption1, TRUE, FALSE, 0);
        gtk_box_pack_start ((GtkBox *)vboxMain, hBoxBuf, TRUE, FALSE, 0);
    }

    gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),vboxMain);

    gtk_widget_show_all(dialog);
    if (gtk_dialog_run(GTK_DIALOG(dialog))== GTK_RESPONSE_ACCEPT){
        ElementStruct->iSaved = 0;
        if (cpType != NULL)
            gtk_list_store_append(ElementStruct->listStore,iter);
        gtk_list_store_set (ElementStruct->listStore, iter, COL_USRCMD_TYPE, gstrType->str, -1);

        g_string_assign (gstrBuf, (bUseText)?gtk_entry_get_text ((GtkEntry *)wdgtText1):"---");
        gtk_list_store_set (ElementStruct->listStore, iter, COL_USRCMD_TEXT, gstrBuf->str, -1);

        g_string_assign (gstrBuf, (bUseVarID)?gtk_entry_get_text ((GtkEntry *)wdgtVarID1):"---");
        gtk_list_store_set (ElementStruct->listStore, iter, COL_USRCMD_VARID, gstrBuf->str, -1);

        g_string_assign (gstrBuf, (bUsePredefine)?gtk_entry_get_text ((GtkEntry *)wdgtPredefine1):"---");
        gtk_list_store_set (ElementStruct->listStore, iter, COL_USRCMD_PREDEFINE, gstrBuf->str, -1);

        g_string_assign (gstrBuf, (bUseTrueValue)?gtk_entry_get_text ((GtkEntry *)wdgtTrueValue1):"---");
        gtk_list_store_set (ElementStruct->listStore, iter, COL_USRCMD_TRUEVALUE, gstrBuf->str, -1);

        g_string_assign (gstrBuf, (bUseFalseValue)?gtk_entry_get_text ((GtkEntry *)wdgtFalseValue1):"---");
        gtk_list_store_set (ElementStruct->listStore, iter, COL_USRCMD_FALSEVALUE, gstrBuf->str, -1);

        g_string_assign (gstrBuf, (bUseButtonText)?gtk_entry_get_text ((GtkEntry *)wdgtButtonText1):"---");
        gtk_list_store_set (ElementStruct->listStore, iter, COL_USRCMD_BUTTONTEXT, gstrBuf->str, -1);

        g_string_assign (gstrBuf, (bUseDialogCaption)?gtk_entry_get_text ((GtkEntry *)wdgtDailogCaption1):"---");
        gtk_list_store_set (ElementStruct->listStore, iter, COL_USRCMD_DIALOGCAPTION, gstrBuf->str, -1);
    }
    gtk_widget_destroy(dialog);

    g_string_free(gstrBuf, TRUE);
    g_string_free(gstrType, TRUE);

    TRACEIT(10,"createUserCommand_addItem		end");
    return 0;
}
