/*
    Copyright 2007, 2008, 2009, 2010 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SEARCHFOR_H_
#define SEARCHFOR_H_


struct SearchParams {
	GString 	*gstrString;
	GList		*glistDirectories;		//filled with GStrings, naming the directories going to be searched.

	char		cUserWasAsked;		// init to 0, becomes 1 if the user was allready asked for search params and the information was stored in here

	//int 		iDeleteByThread;	// 1 if the search thread has to delete this struct, 0 otherwise
	int			iBreak;				//init to 0
	int			iDeleteNotification;	//init to 0;

	GtkWidget	*actionWidget;
	GtkWidget 	*actionWidgetLabel;

	int 		iFileShelfID;		//init to -1
	struct FileShelfObjectList *pFileShelfObject;
};


struct SearchParams 	*searchParams_new ();
void					searchParams_delete(struct SearchParams *pStru);
void 					searchParams_copyMember(struct SearchParams *pStruDest, struct SearchParams *pStruSrc);

gboolean				search_PerformSearchParamsOnItem (const char *cpItemName, const struct SearchParams *pSearchStru);

//this is our main search function
int find_simple(GList *glistDirectories );


#endif //SEARCHFOR_H_
