/*
    Copyright 2007, 2008, 2009, 2010 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CONFIGHANDLINGDEFINITIONS_H_
#define CONFIGHANDLINGDEFINITIONS_H_

#define CATSEYEHOMEDIR ".catseye"
#define CONFIG_FILE_TYPES ".catseye/catseye_XML_config_file.conf"
#define SAVE_FILE ".catseye/.catseye_saves"
#define PROGRAMSEPERATOR ";"		//not used in future
#define TYPESEPARATOR ":"			//not used in future

////////!!!!!!!!!!!!!!!!!      ONLY LOW CHARACTERS ARE ALLOWED!!!!!

////////Configfile /////////////
#define STANDARDEDITORKEY "stded"	//standard editor
#define SAVEPATHESONEXIT "svpths"	//Save pathes on exit, this is just for the decision wether to load or not, the pathes are stored in another file
#define TERMINALKEY "trmnl"			//terminal
#define STANDARDSTARTDIRECTORY "strdd"	//Directory opened when calling new page from popup menue at the notebooks
#define STARTDIRECTORIESLEFTKEY "strtdl"	//Directories loaded on start, left side
#define STARTDIRECTORIESRIGHTKEY "strtdr"	//Directories loaded on start, right side
#define PREVIEWSIZE "prvsize"   //the size of the previews (picture can be previewed) (a string like 24x24 or 24x0 or 0x24, where 0 means that the ratio should be fix, is this possible?)
#define PREVIEWTYPES "prvtypes" //the file types they are previewed, a string of file endings divided by spaces ( jpg png )
#define DEFAULT_PREVIEWSIZE "24x24"
#define SAVESESSIONMINUTESTYPES "svssnmnts"
#define DEFAULT_SAVESESSIONMINUTES 0	//this no char (0 = off)

#define COLOR_ITEMS_DEFAULT "clritm"
#define COLOR_DIRECTORIES   "clrdir"
#define COLOR_LINKS         "clrlnk"
#define COLOR_ITEMS_MISSING "clrmss"
#define DEFAULT_COLOR_ITEMS_DEFAULT "Black"
#define DEFAULT_COLOR_DIRECTORIES   "Blue"
#define DEFAULT_COLOR_LINKS         "CornflowerBlue"
#define DEFAULT_COLOR_ITEMS_MISSING "Red"

#define COLUMN_ORDER "clmnord"
#define COLUMN_ORDER_SEPARATOR "\" \""		//used as separator to store the order of the columns, mind that we want to set names between '"'

#define COUNTSFORALLITEMSKEY "allfls"	//A filetype identifier which defines userprograms which can used on all types of items (e.g. packing)

///////// Savefile //////////
#define LASTSIZE_X "sizex"
#define LASTSIZE_Y "sizey"

#define ALWAYS_SHOW_HIDDEN "alwshdn"	//Identifier within the savefile. Set or unset from within the internal menu. Uses a global varibale (int g_int_AlwaysShowHidden)

#define LASTPATHESLEFTKEY "lpl"	//in the file where the pathes are stored and loaded again on restart, these are the identifier for left and right
#define LASTPATHESRIGHTKEY "lpr"

#define LASTPATHLEFTID "lpl%dp"	//these are the identifier used in the savedfile to save the pathes ...
#define LASTPATHRIGHTID "lpr%dp"
#define LASTPATHLEFTHIDDENID "lpl%dh"	//... and hidden property
#define LASTPATHRIGHTHIDDENID "lpr%dh"
#define LASTPATHLEFTPREVIEWID "lpl%dv" //... and the preview flag
#define LASTPATHRIGHTPREVIEWID "lpr%dv"
#define LASTPATHLEFTREADONLYID "lpl%dro" // ... and the read only flag
#define LASTPATHRIGHTREADONLYID	"lpr%dro"

////////// XML - Configfile Keys ////////////////////
#define XMLTAG_MAIN "CatsEyE"
#define XMLTAG_BOOKMARKS "CatsEyEBookmarks"
#define XMLTAG_OPTIONS "CatsEyEOptions"
#define XMLTAG_USERCOMMANDS "CatsEyEUsercommands"
#define XMLTAG_USERCOMMAND "Usercommand"
#define XMLTAG_OBJECT "Object"
#define XMLTAG_OPTION "Option"
#define XMLTAG_ID "ID"
#define XMLTAG_NAME "Name"
#define XMLTAG_VALUE "Value"
#define XMLTAG_TYPE "type"
#define XMLTAG_QUESTION "question"
#define XMLTAG_CHECKBOX "checkbox"
#define XMLTAG_TEXT "text"
#define XMLTAG_SEPARATOR "separator"
#define XMLTAG_FILECHOOSER "filechooser"
#define XMLTAG_DIRCHOOSER "dirchooser"
#define XMLTAG_DEFAULTCOMMAND "Defaultcommand"
#define XMLTAG_TARGET "Target"
#define XMLTAG_COMMAND "Command"
#define XMLTAG_CALLTYPE "Calltype"
#define XMLTAG_QUITREPLY "OptionQuitreply"
#define XMLTAG_ACTIONNOTE "OptionActionnote"
#define XMLTAG_LISTCAPTION "OptionCaption"
#define XMLTAG_LISTLABEL "OptionLabel"
#define XMLTAG_DIALOGCAPTION "DialogCaption"
#define XMLTAG_DIALOGLABEL "DialogLabel"
#define XMLTAG_VARID "VarID"
#define XMLTAG_LABELTEXT "LabelText"
#define XMLTAG_PREDEFINE "Predefine"
#define XMLTAG_TRUEVALUE "TrueValue"
#define XMLTAG_BUTTONTEXT "ButtonText"
#define XMLTAG_FALSEVALUE "FalseValue"
#define XMLTAG_CHOOSERCAPTION "ChooserCaption"


#endif //CONFIGHANDLINGDEFINITIONS_H_
