/*
    Copyright 2007, 2008, 2009, 2010 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef HELPERS_H_
#define HELPERS_H_

struct ListWidgetCommunicationStruct;
struct CopyReMoveList;



void 		textbuffer_commandHistory_addText (char *text, char *tag);
gboolean 	myWrapOf__g_spawn_command_line_sync (const gchar *command_line, gchar **standard_output, gchar **standard_error, gint *exit_status, GError **error, gboolean ThreadSave);
void 		CancelButtonFunctionForIBreak(GtkButton *button, gpointer data);   //used as callback function

void CursorToWait(GtkWidget *widget);
void CursorToNormal(GtkWidget *widget);

//Information aquiring
double  GetTimeMine(GTimeVal time);
int 	getHomeDirectory(GString *HomeDir);
int 	completePath(char *cpText, char **ToComplete);
gboolean checkStringIsPath(char *cpPath);
int		getRandomIntNumber(int iMin, int iMax);
GFile   *getCorrectGFileTypeFromLocation(char *location, int *iType);
int     manipulateCounter (int *iCounter, gboolean bCountUp, const char *ccpSource);
int     checkItemIsLink (const char *ccpItem);

//String manipulation
int  CheckForEndingInEndingList (const char *ccpEndings, const char *ccpSingleEnding);
void BytesToHumanity(guint64 bytes, double *newBytes, int *iEPow, GString *gstrEPow);
void BytesToHumanityString (guint64 bytes, GString *gstrBytesString, int decimalplaces);
char *mine_strnstr(char *big, char *little, int size);
int  myTokenFunction (GString *gstrCompleteString, int TokenNumber, char *devider, GString *gstrToken);
void cutSpacesFromGString(GString *ToCut);
void cutLeadingSpacesFromGString(GString *ToCut);
void checkPathForLastChar(GString *Path);
void checkPathForLastCharOtherwise(GString *Path);
void cutTapsFromGString(GString *ToCut);
void cutCharFromGString(GString *ToCut, char thechar, int OnlyLeadingOnes);
void getLastStringInPath(GString *Path);
int  GetPathFromPathWithName(GString *PathAndName, int iDoIt);
void cutStringToNChars(GString *Text,int Size);
void cleverCutStringToNChars(GString *ToCut, char *textToAddBetween, int Size);
int exchangeNameWithValue(GString *gstrText, GString *gstrEnemy, GString *NewString);
int ExchangeSpecialCharachterForXML (GString *gstrText);

//Data Storage manipulation
int AddNewGStringToDPointer(GString ***gstrTPString,int OldCount, GString *NewOne);
int AddNewGUInt64ToPointerArray(guint64 **intArray, int OldCount, guint64 NewOne);
void *GListFreeGStrings (gpointer data, gpointer user_data);		//use it with: g_list_foreach(listDirs, (GFunc) GListFreeGStrings, NULL); g_list_free(listDirs);

//Widgets
GtkWidget 	*CreateMyWindow(char *title, GtkWindow *parent, int x, int y, gboolean bResizeable, gboolean bDestroyWithParent, gboolean bKeepOnTop, int *iDeleteNotification, gboolean bParentInteraction, gboolean bDeletable);
GtkWidget   *CreateMyDialog(char *title, GtkWindow *parent, int iButtons, char *respText1, int resp1, char *respText2, int resp2, char *respText3, int resp3, gboolean bResizeable);
void 		MyMessageWidget(GtkWindow *parrent, char *title, char* message);
int 		MyEasyInputWidget (GtkWindow *parrent, char *title, char *text, GString *gstrUserText);
int 		MyEasyInputWidget_Two (GtkWindow *parrent, char *title, char *text1, GString *gstrUserText1, char *text2, GString *gstrUserText2, char *button0, char *button1, char *button2, char *button3);
void 		MyEasyInputWidget_EntryBoxActivate(GtkEntry *entry, gpointer data);
void 		AddMyIconsToWindow(GtkWindow *Window);
int 		scrollListStoreToName(GtkTreeView *listView, GtkListStore *listStore, GString *NameToScroll, int ColumnToSearch);
//int         AddESCButtonToAMainWidget (GtkWidget *TheWidget);
//gboolean    AddESCButtonToAMainWidget_SignalHandler(GtkWidget *widget, GdkEventKey *event, GtkWidget *TheWidget);


gboolean ListWidget_MousePressEventCatcher (GtkWidget *widget, GdkEventButton *event, struct ListWidgetCommunicationStruct *commStru);

struct AllInformationAllUseStruct{	//a structure which holds plenty of information for much functions
	//created when working on fileshelf to make use of functions which are ment for the normal Objects
	//and, with the help of this structure, can now be used for the fileshelf too.
	//But this structure can be used everywhere where more information has to be exchanged with only one pointer

	int source;	//filled with one item of the enum above. E.g. SOURCE_FILESHELFT
	void *Info_1;	// this becomes: struct CallUserDataStruct *TheStruct = info->Info_1;
	void *Info_2;	// holds info->Info_2=(void *)ItemList;  (FileList)
	void *Info_3;	// used for fileshelf in special, holds listView from fileshelf
	void *Info_4;	// used for fileshelf, holds the path from the first marked item
    void *Info_5;
    void *Info_6;
};

#endif //HELPERS_H_

