/*
    Copyright 2007, 2008, 2009, 2010 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifdef THREADDEBUG

#include <stdio.h>
#include <gtk/gtk.h>
#include "mytrace.h"

#include "allInclude.h"

int g_iThreadNumber=0;
int g_iTooManyThreads=0;

void myWrap_gdk_threads_enter(char *cpSource){
    TRACEIT (10, "myWrap_gdk_threads_enter		start");
    if ( (g_iThreadNumber >= 3 && g_iTooManyThreads == 0) || THREADDEBUG > 1){
        printf("going to be thread save at position: %s, Number: %d ...",cpSource, g_iThreadNumber);
    }
	gdk_threads_enter();
	g_iThreadNumber++;
	if ( (g_iThreadNumber >= 3 && g_iTooManyThreads == 0 ) || THREADDEBUG > 1){
        printf("        ... We are threadSave now, Number:%d\n",g_iThreadNumber);
        g_iTooManyThreads = 1;
	}
	TRACEIT (10, "myWrap_gdk_threads_enter		end");
}

void myWrap_gdk_threads_leave(char *cpSource){
	TRACEIT (10, "myWrap_gdk_threads_leave		start");
	if ((g_iThreadNumber >= 3 && g_iTooManyThreads == 0) || THREADDEBUG > 1){
        printf("going to UNbe threadSave at position: %s, Number: %d...",cpSource, g_iThreadNumber);
	}
	gdk_threads_leave();
	g_iThreadNumber--;
	if ((g_iThreadNumber >= 3 && g_iTooManyThreads == 0) || THREADDEBUG > 1){
        printf("        ... We leaved threadSave, Number: %d\n", g_iThreadNumber);
        g_iTooManyThreads = 1;
	}
	TRACEIT (10, "myWrap_gdk_threads_leave		end");
}
#endif












